﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FlyGame
{
    class Program
    {
        #region 数组,变量
        //在map数组中存储各个关卡的地图
        //在map数组中元素值1：表示幸运轮盘  图标-->   ◎
        //在map数组中元素值2: 表示地雷      图标-->   ★
        //在map数组中元素值3：表示暂停      图标-->   ▲
        //在map数组中元素值4：表示时空隧道  图标-->   卐
        //在map数组中元素值0：表示普通      图标-->   □
        public static int[] Map = new int[100];  //地图关卡数
        public static int[] NameNum ={0,0};//玩家 NameNum[0]表示玩家A，NameNum[1]表示玩家B
        public static string[] PlayerName = new string[2];//该数组存储玩家姓名
        public static Random random = new Random(); //产生一个随机数
        public static int stempA = 0;               //存放玩家A掷的数
        public static int stempB = 0;               //存放玩家B掷的数 
        public static string str;                   //存放玩家A或玩家B掷色子后的情况
        public static bool bA = true;         //玩家A是否暂停
        public static bool bB = true;         //玩家B是否暂停

        public static int iA = 0;   //表示玩家A暂停的次数
        public static int iB = 0;   //表示玩家B暂停的次数
        #endregion

        #region 程序入口
        /// <summary>
        /// 程序入口
        /// </summary>
        /// <param name="args">string[]</param>
        static void Main(string[] args)
        {
           
            #region 游戏初始化
            ShowUI();  //显示界面
            Console.WriteLine("请输入玩家A的姓名：");
            PlayerName[0]=Console.ReadLine();
            while (true)
            {
                if (PlayerName[0] == "")
                {
                    Console.WriteLine("玩家A的姓名不能为空！请重新输入：");
                    PlayerName[0] = Console.ReadLine();
                    continue;
                }
                break;
            }
            Console.WriteLine("请输人玩家B的姓名：");
            PlayerName[1] = Console.ReadLine();
            while (true)
            {
                if (PlayerName[1] == "")
                {
                    Console.WriteLine("玩家B的用户名不能为空！请重新输入：");
                    PlayerName[1] = Console.ReadLine();
                    continue;
                }
                if (PlayerName[1] == PlayerName[0])
                {
                    Console.WriteLine("该用户名已被注册！请重新输入：");
                    PlayerName[1] = Console.ReadLine();
                    continue;
                }
                break;
            }
            Console.Clear();
            ShowUI();    //显示游戏界面
            Console.WriteLine("玩家“{0}”\t------>用“A”表示！", PlayerName[0]);
            Console.WriteLine("玩家“{0}”\t------>用“B”表示！", PlayerName[1]);
            Console.WriteLine("开始游戏......");
            InitialMap();//初始化地图
            DrawMap();//画地图
            #endregion

            #region 玩家A或玩家B掷色子玩游戏
            while (true)
            {
               
                if (NameNum[0] >= 99 || NameNum[1] >=99)
                {
                    break;
                }
                else
                {
                    if (bA)
                    {
                        if (bB == false)
                        {
                            iB++;
                        }
                        if (iB == 2)
                        {
                            bB = true;
                        }
                        #region 玩家A开始掷色子
                        Console.WriteLine("玩家A”{0}“按任意键掷色子！", PlayerName[0]);
                        Console.ReadKey(true);

                        stempA = random.Next(1, 7);   //玩家A所掷的数
                        Console.WriteLine("“{0}”掷出了----〉{1}", PlayerName[0], stempA);
                        NameNum[0] += stempA;         //玩家掷色子后位置
                        SlopOver();                //处理玩家A越界后的位置
                        GameStart(0, 1, stempA,ref bA,ref bB);
                        #endregion
                    }
                    if (bB)
                    {
                        if (bA == false)
                        {
                            iA++;
                        }
                        if (iA == 2)
                        {
                            bA = true;
                        }
                        #region 玩家B开始掷色子
                        Console.WriteLine("玩家B”{0}“按任意键掷色子！", PlayerName[1]);
                        Console.ReadKey(true);
                        stempB = random.Next(1, 7);   //玩家A所掷的数
                        Console.WriteLine("“{0}”掷出了----〉{1}", PlayerName[1], stempB);
                        NameNum[1] += stempB;         //玩家掷色子后位置
                        SlopOver();                //处理玩家A越界后的位置
                        GameStart(1, 0, stempB,ref bB,ref bA);
                        #endregion
                    }//ifb结束
                }//while结束
            }
            #endregion

            if (NameNum[0] == 99)
            {
                Console.WriteLine("玩家A”{0}“胜利！！！", PlayerName[0]);
                Win();

            }
            if (NameNum[1] == 99)
            {
                Console.WriteLine("玩家A”{0}“胜利！！！", PlayerName[1]);
                Win();
            }
            
            Console.ReadKey();

        }
        #endregion

        #region  显示UI界面
        /// <summary>
        /// 显示UI界面
        /// </summary>
        public static void ShowUI()
        {
            Console.ForegroundColor = ConsoleColor.Red;
            Console.WriteLine("                                 游戏                               ");
            Console.WriteLine("**********************************************************************");
            Console.WriteLine("*                                                                    *");
            Console.WriteLine("*                         骑  士  飞  行  棋                         *");
            Console.WriteLine("*                                                                    *");
            Console.WriteLine("**********************************************************************");
            Console.ForegroundColor = ConsoleColor.White;
        }
        #endregion

        #region 初始化地图
        /// <summary>
        /// 初始化地图
        /// </summary>
        public static void InitialMap()
        {
            int[] luckyTurn = { 6, 23, 40, 55, 69, 83, 91 };       //幸运轮盘
            for (int i = 0; i < luckyTurn.Length; i++)
            {
                Map[luckyTurn[i]] = 1;
            }
            int[] lindMine = { 5, 13, 17, 33, 38, 50, 64, 80, 94 };  //地雷
            for (int i = 0; i < lindMine.Length; i++)
            {
                Map[lindMine[i]] = 2;
            }
            int[] pause = { 9, 27, 60, 93 };                    //暂停
            for (int i = 0; i < pause.Length; i++)
            {
                Map[pause[i]] = 3;
            }
            int[] timeTnnel = { 20, 25, 45, 63, 72, 88, 90 };     //时空隧道
            for (int i = 0; i < timeTnnel.Length; i++)
            {
                Map[timeTnnel[i]] = 4;
            }
        }
        #endregion

        #region 画地图
        /// <summary>
        /// 画地图
        /// </summary>
        public static void DrawMap()
        {
            Console.WriteLine("\n图例：幸运轮盘：◎\t地雷：★\t暂停：▲\t时空隧道：卐\n");
            #region   画第一行
            for (int i = 0; i <= 29; i++)
            {
                Console.Write(ShowIcon(i));
            }
            Console.WriteLine();
            #endregion

            #region 画第一列
            for (int i = 30; i <= 34; i++)
            {
                for (int j = 0; j < 29; j++)
                {
                    Console.Write("  ");
                }
                Console.WriteLine(ShowIcon(i));
            }
            #endregion

            #region 画第二行
            for (int i = 64; i >= 35; i--)
            {
                Console.Write(ShowIcon(i));
            }
            Console.WriteLine();
            #endregion

            #region 画第二列
            for (int i = 65; i <= 69; i++)
            {
                Console.WriteLine(ShowIcon(i));
            }
            #endregion

            #region 画第三行
            for (int i = 70; i <= 99; i++)
            {
                Console.Write(ShowIcon(i));
            }
            #endregion
            Console.ForegroundColor = ConsoleColor.White;
            Console.WriteLine("\n");
        }
        #endregion

        #region  根据Map数组元素值绘图标
        /// <summary>
        /// 根据Map数组元素值绘图标
        /// </summary>
        /// <param name="i">int</param>
        /// <returns>string</returns>
        public static string ShowIcon(int i)
        {
            string icon = "";
            if (NameNum[0] == NameNum[1] && NameNum[1] == i)  //如果A和B位置相同
            {
                Console.ForegroundColor = ConsoleColor.White;
                icon="<>";
            }
            else if (NameNum[0] == i)                        //玩家A的位置
            {
                Console.ForegroundColor = ConsoleColor.White;
                icon="Ａ";
            }
            else if (NameNum[1] == i)                        //玩家B的位置
            {
                Console.ForegroundColor = ConsoleColor.White;
                icon="Ｂ";
            }
            else                                             //各个关卡的图标
            {
                switch (Map[i])
                {
                    case 0:
                        Console.ForegroundColor = ConsoleColor.White;
                       icon="□";                //普通关卡
                        break;
                    case 1:
                        Console.ForegroundColor = ConsoleColor.Blue;
                        icon="◎";               //幸运轮盘
                        break;
                    case 2:
                        Console.ForegroundColor = ConsoleColor.Green;
                        icon="★";               //地雷
                        break;
                    case 3:
                        Console.ForegroundColor = ConsoleColor.Red;
                        icon="▲";               //暂停
                        break;
                    case 4:
                        Console.ForegroundColor = ConsoleColor.Yellow;
                        icon="卐";               //时空穿梭机
                        break;
                }
                
            }
            
            return icon;
        }
        #endregion

        #region 处理玩家A或玩家B越界后的位置
        /// <summary>
        /// 处理玩家A或玩家B越界后的位置
        /// </summary>
        public static void SlopOver()
        {
            for (int i = 0; i < 2; i++)
            {
                if (NameNum[i] > 99)
                {
                    NameNum[i] = 99;
                }
                if (NameNum[i] < 0)
                {
                    NameNum[i] = 0;
                }
            }
            
        }
        #endregion

        #region 判断一个数字输入的是否正确,并判读数字是否超出指定范围
        /// <summary>
        /// 判断一个数字输入的是否正确,并判读数字是否超出范围
        /// </summary>
        /// <param name="strs">用户输入的数字</param>
        /// <param name="min">最小值</param>
        /// <param name="max">最大值</param>
        /// <returns></returns>
        public static int NumIsTrueOrFalse(string strs, int min, int max)
        {
            int num = 0;
            while (true)
            {
                try
                {
                    num = Convert.ToInt32(strs);
                    if (num < min || num > max)
                    {
                        Console.WriteLine("输入数字超出规定范围，请重新输入：");
                        strs = Console.ReadLine();
                        continue;
                    }
                    break;
                }
                catch
                {
                    Console.WriteLine("异常输入，请重新输入：");
                    strs = Console.ReadLine();
                }
            }
            return num;
        }
        #endregion

        #region 玩家A或玩家B掷色子后，执行游戏
        /// <summary>
        /// 玩家A或玩家B掷色子后，执行游戏
        /// </summary>
        /// <param name="num1">玩家A或玩家B</param>
        /// <param name="num2">玩家A或玩家B</param>
        public static void GameStart(int num1, int num2,int num3,ref bool b,ref bool b1)
        {
            
            SlopOver();                //处理玩家A越界后的位置
            if (NameNum[num1] == NameNum[num2])       // 玩家A踩到了玩家B
            {
                str = "玩家”" + PlayerName[num2] + "”被踩回了原点";
                NameNum[num2] = 0;                 //被踩到的玩家B的位置设为0
            }
            else
            {
                switch (Map[NameNum[num1]])
                {
                    case 0:
                        str = "”"+PlayerName[num1]+"“前进了"+num3+"格";
                        break;
                    case 1:      //幸运轮盘
                        Console.WriteLine("请选择（幸运轮盘：1.交换位置，2.轰炸对方）：");
                        string strs = Console.ReadLine();
                        int num = NumIsTrueOrFalse(strs, 1, 2);
                        if (num == 1)        //玩家A或玩家B
                        {
                            str = "玩家”"+PlayerName[num1]+"“和玩家”"+PlayerName[num2]+"“交换位置！";
                            int temp = NameNum[num1];
                            NameNum[num1] = NameNum[num2];
                            NameNum[num2] = temp;
                        }
                        else
                        {
                            str = "”"+PlayerName[num2]+"“被轰炸，后退6格";
                            NameNum[num2] -= 6;   //玩家B被轰炸，后退6格
                            SlopOver();
                        }
                        break;
                    case 2:      //地雷
                        str = "”" + PlayerName[num1] + "“踩到了地雷被轰炸，后退6格";
                        NameNum[num1] -= 6;      //玩家A踩到地雷，后退6格
                        SlopOver();
                        break;
                    case 3:      //暂停
                        str = "“" + PlayerName[num1] + "”踩到了三角，暂停一次！";
                        b = false;
                        b1 = true;
                        break;
                    case 4:      //时空穿梭机
                        str = "”" + PlayerName[num1] + "“坐上了时空穿梭机，前进10格";
                        NameNum[num1] += 10;     //坐上时空穿梭机，前进十格
                        SlopOver();
                        break;
                } //switch结束
            }
            Console.WriteLine("“{0}“按任意键开始行动！", PlayerName[num1]);
            Console.ReadKey(true);
            Console.Clear();
            DrawMap();
            Console.ForegroundColor = ConsoleColor.Cyan;
            Console.WriteLine("\n**************************位置报告*********************************");
            Console.WriteLine("                     {0}  ",str);
            Console.WriteLine("                     玩家{0}的位置是{1}",PlayerName[num1],NameNum[num1]);
            Console.WriteLine("                     玩家{0}的位置是{1}", PlayerName[num2], NameNum[num2]);
            Console.WriteLine("*******************************************************************");
            Console.ForegroundColor = ConsoleColor.White;

        }
        #endregion

        #region 胜利
        /// <summary>
        /// 胜利
        /// </summary>
        public static void Win()
        {
            Console.ForegroundColor = ConsoleColor.Red;
            Console.WriteLine("                                          ◆                      ");
            Console.WriteLine("                    ■                  ◆               ■        ■");
            Console.WriteLine("      ■■■■  ■  ■                ◆■         ■    ■        ■");
            Console.WriteLine("      ■    ■  ■  ■              ◆  ■         ■    ■        ■");
            Console.WriteLine("      ■    ■ ■■■■■■       ■■■■■■■   ■    ■        ■");
            Console.WriteLine("      ■■■■ ■   ■                ●■●       ■    ■        ■");
            Console.WriteLine("      ■    ■      ■               ● ■ ●      ■    ■        ■");
            Console.WriteLine("      ■    ■ ■■■■■■         ●  ■  ●     ■    ■        ■");
            Console.WriteLine("      ■■■■      ■             ●   ■   ■    ■    ■        ■");
            Console.WriteLine("      ■    ■      ■            ■    ■         ■    ■        ■");
            Console.WriteLine("      ■    ■      ■                  ■               ■        ■ ");
            Console.WriteLine("     ■     ■      ■                  ■           ●  ■          ");
            Console.WriteLine("    ■    ■■ ■■■■■■             ■              ●         ●");
            Console.ResetColor();
        }
        #endregion


    }
}
